Code

Merge branch 'maint'
[git.git] / git-sh-setup.sh
index b366761b976a136144c7483de5c883a084996816..a44b1c74a38d6310d7a1bde969cbbcb51f977188 100755 (executable)
@@ -18,7 +18,8 @@ die() {
 
 if test -n "$OPTIONS_SPEC"; then
        usage() {
-               exec "$0" -h
+               "$0" -h
+               exit 1
        }
 
        parseopt_extra=
@@ -118,33 +119,22 @@ get_author_ident_from_commit () {
        }
        '
        encoding=$(git config i18n.commitencoding || echo UTF-8)
-       git show -s --pretty=raw --encoding="$encoding" "$1" |
+       git show -s --pretty=raw --encoding="$encoding" "$1" -- |
        LANG=C LC_ALL=C sed -ne "$pick_author_script"
 }
 
 # Make sure we are in a valid repository of a vintage we understand,
 # if we require to be in a git repository.
-if test -n "$NONGIT_OK"
+if test -z "$NONGIT_OK"
 then
-       if git rev-parse --git-dir >/dev/null 2>&1
-       then
-               : ${GIT_DIR=.git}
-       fi
-else
+       GIT_DIR=$(git rev-parse --git-dir) || exit
        if [ -z "$SUBDIRECTORY_OK" ]
        then
-               : ${GIT_DIR=.git}
                test -z "$(git rev-parse --show-cdup)" || {
                        exit=$?
                        echo >&2 "You need to run this command from the toplevel of the working tree."
                        exit $exit
                }
-       else
-               GIT_DIR=$(git rev-parse --git-dir) || {
-                   exit=$?
-                   echo >&2 "Failed to find a valid git directory."
-                   exit $exit
-               }
        fi
        test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
                echo >&2 "Unable to determine absolute path of git directory"